#pragma once
#include <unordered_map>
#include <map>
#include <deque>
#include <iostream>
#include "SyncTimeMsg.h"
#include "Position.h"
#include "Common.h"
#include "SyncTime.h"
#include "SyncHelper.h"
#include "TagMsg.h"

using namespace std;

namespace HostServer{
    class SyncManager
    {
		struct SyncTimeMsgItem
		{
			unsigned short SyncNum;
			unordered_map<unsigned long long, SyncTimeMsg> SyncTimeMsgs;
		};
		struct SyncTimeItem
		{
			unsigned short SyncNum;
			unordered_map<unsigned long long, SyncTime> HistSync;
		};

		CRITICAL_SECTION m_csSyncTime;
		CRITICAL_SECTION m_csCalcLiner;

    public:
        SyncManager();
		~SyncManager();

        //************************************
        // Description: ڳʼгԱ
        // Method:      init
        // Returns:     void
        //************************************
        void init();

        //************************************
        // Description: ڽʱͬmsgе
        // Method:      analyzeMsg
        // Returns:     void
        // Parameter:   SyncTimeMsg & msg socketȡϢ
        //************************************
        void analyzeSyncMsg(SyncTimeMsg &msg);

        //************************************
        // Description: ڷTagλϢλ
        // Method:      analyzeTagMsg
        // Returns:     Position
        // Parameter:   TagRecord & tagMsg
        // Parameter:   unsigned long long tagId
        // Parameter:   unsigned short tagNum
        //************************************
        Position analyzeTagMsg(TagMsg &tagMsg, unsigned long long tagId, unsigned short tagNum);

        //************************************
        // Description: ¾Ϣ
        // Method:      updateDistance
        // Returns:     void
        // Parameter:   unsigned int localId ǰվ
        // Parameter:   unsigned char localAntNum ǰվߺ
        // Parameter:   unsigned int upperId ϼվ
        // Parameter:   unsigned char uppderAntNum ϼվߺ
        // Parameter:   int d 
        //************************************
        void updateDistance(unsigned int localId, unsigned char localAntNum, unsigned int upperId, unsigned char uppderAntNum, double d);

        //************************************
        // Description: anchorϢ
        // Method:      updateAnchor
        // Returns:     void
        // Parameter:   unsigned int localId ǰվ
        // Parameter:   unsigned char localAntNum ǰվߺ
        // Parameter:   int x
        // Parameter:   int y
        // Parameter:   int z
        //************************************
        void updateAnchor(unsigned int localId, unsigned char localAntNum, double x, double y, double z);

        //************************************
        // Description: ɾanchor
        // Method:      deleteAnchor
        // Returns:     void
        // Parameter:   unsigned int localId ǰվ
        // Parameter:   unsigned char localAntNum ǰվߺ
        //************************************
        void deleteAnchor(unsigned int localId, unsigned char localAntNum);

		// unsigned long longanchor ID+AntNum
        unordered_map<unsigned long long, Position> _anchors; 
        // unsigned long long anchor ID+AntNum
        unordered_map<unsigned long long,unordered_map<unsigned long long, double>> _distance; 

        // ʹ_syncTimeMsgs[SyncNum][LocalIdCode]ʶӦSyncTimeMsg,ͬʱϢ
        //unordered_map<unsigned short, unordered_map<unsigned long long, SyncTimeMsg>> _syncTimeMsgs;
		deque<SyncTimeMsgItem> _syncTimeMsgs;

        // ʹ_historySync[SyncNum][LocalIdCode]ʶӦSyncTimeʱͬ
        //unordered_map<unsigned short, unordered_map<unsigned long long, SyncTime>> _historySync;
		deque<SyncTimeItem> _historySync;

        // ʹ_tagRecords[TagId][TagNum]ʶӦTagRecordбTagIdΪTagıţTagNumΪTagк
        unordered_map<unsigned long long,unordered_map<unsigned short, vector<TagMsg>>>_tagRecords;

        //************************************
        // Description: Tagļ¼ʷmsgԲֵ㷨TagԤʱ
        // Method:      calTimeByLinar
        // Returns:     unsigned long long 
        // Parameter:   unsigned long long tagReceiveTime tagĽʱ
        // Parameter:   unsigned short SyncNum  tagʱʱͬ
        // Parameter:   unsigned long long localIdCode taganchorID
        //************************************
        unsigned long long calTimeByLinar(TagMsg &tag);

        //************************************
        // Description: ڸʱͬĸ
        // Method:      updateSync
        // Returns:     bool
        // Parameter:   unsigned short SyncNum
        // Parameter:   unsigned long long localIdCode
        //************************************
        bool updateSync(int idx, unsigned short SyncNum, unsigned long long localIdCode);
		int FindSyncTimeMsg(unsigned short SyncNum);
		int FindSyncTime(unsigned short SyncNum);
    };
}